// fk_TrackBallNX
// }EXł̎RȎ_񋟂܂B

#ifndef __FK_TRACKBALL_HEADER__
#define __FK_TRACKBALL_HEADER__

#include <FK/Window.h>
#include <FK/Model.h>
#include <FK/Vector.h>
#include <FK/Angle.h>
#include <Fl/Fl.h>

class fk_TrackBall {

private:
	fk_Window	*fk_win;							// FKEBhE
	fk_Model	*camera;							// J
	fk_Vector	lookPos;							// Rl̎__

	int			nowX, nowY, oldX, oldY;				// EBhEW
	int			echoX, echoY;
	bool		lookClick, distClick, moveClick;	// 1[vÕNbNL

public:
	fk_TrackBall(fk_Window*, fk_Model* = NULL);		// RXgN^

	// <vpeB

	// Ɏgp}EX{^̎w
	fk_MouseButton	lookButton, distButton[2], moveButton;

	bool		overCheck;							// ʊOɃJ[\oꍇ̗̔L
	double		divPos, divLook;					// J[\ړ:ʔ䗦w
	double		divDist;							// Rl̎_J[\ړ:ʔ䗦w

	bool		bEcho;								// GR[̗L

	// >

	void		setCamera(fk_Model*);				// J̕ύX
	bool		isSetCamera(void);					// J|C^͓nĂ邩

	void		setLookTo(fk_Vector);				// Rl̎__ύX

	void		controlLookTo(void);				// Rl̎_ʒu
	void		controlLookToDist(void);			// Rl̎_
	void		controlLookToMove(void);			// Rl̎__

	void		controlLookToSC(void);				// Rl̎_V[gJbg

	void		update(void)
	{
		controlLookToMove();
		controlLookToDist();
		controlLookTo();
	}

};

#endif
